/**
 * @file
 * VuoList_VuoMidiNote C type definition.
 *
 * @copyright Copyright © 2012–2013 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoMidiNote_H
#define VuoList_VuoMidiNote_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoMidiNote VuoList_VuoMidiNote
 * A list of @ref VuoMidiNote elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

/**
 * @typedef VuoList_VuoMidiNote
 * A list of @ref VuoMidiNote elements.
 */
#ifndef VuoList_VuoMidiNote_TYPE_DEFINED
typedef void * VuoList_VuoMidiNote;
#endif

/**
 * Creates a new list of @ref VuoMidiNote elements.
 */
VuoList_VuoMidiNote VuoListCreate_VuoMidiNote(void);

/**
 * Returns the @ref VuoMidiNote at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoMidiNote VuoListGetValueAtIndex_VuoMidiNote(const VuoList_VuoMidiNote list, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoMidiNote(VuoList_VuoMidiNote list, const VuoMidiNote value);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoMidiNote(VuoList_VuoMidiNote list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoMidiNote(VuoList_VuoMidiNote list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoMidiNote(const VuoList_VuoMidiNote list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoMidiNote VuoList_VuoMidiNote_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoMidiNote_jsonFromValue(const VuoList_VuoMidiNote value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoMidiNote_summaryFromValue(const VuoList_VuoMidiNote value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoMidiNote VuoList_VuoMidiNote_valueFromString(const char *str);
char * VuoList_VuoMidiNote_stringFromValue(const VuoList_VuoMidiNote value);
/// @}

/**
 * @}
 */

#endif
